#!/usr/local/bin/ruby
# $Id: rtds.rb,v 1.5 2002/05/21 10:29:45 kazane Exp $

require "cgi"
require "kconv"
include File::Constants

title				= "users_diary"
sufix				= ".html"
base_directory		= "./"
plugin_directory	= "#{base_directory}/plug-in/"
filter_directory	= "#{base_directory}/filter/"
index_base_file		= "#{base_directory}/html/indexbase"
diary_base_file		= "#{base_directory}/html/diarybase"
index_file			= "#{base_directory}/index#{sufix}"
diarytable_file		= "#{base_directory}/html/diarytable"
category_file		= "#{base_directory}/html/category"

R_MEANS		= "<abbr title=\"Ruby Tiny Diary System\">RTDS</abbr>"
R_VERSION	= "0.2.1"
R_CODE		= "White Lady"
RTDS		= "<a href=\"http://wids.net/lab/rtds.html\">#{R_MEANS}</a> version #{R_VERSION} (#{R_CODE})"

class Rtds_str 
	def initialize
		@str = ""
		@result = ""
		@category = ""
		@cnt = "00"
		@fn_cnt = "00"
		@fn_str = ""
		@cgi = CGI.new
		@year = @cgi['year'][0]
		@month = @cgi['month'][0]
		@day = @cgi['day'][0]
		@comment = @cgi ['comment'][0]
		@time = "#{@year}#{@month}#{@day}"
		@filter_list = ""
	end

	def set_config(category_file,filter_directory)
		@category_file = category_file
		@filter_directory = filter_directory
	end

	def categorize(str)
		@category = ""
		@category_str = open(@category_file,"r").read
		@category_str.each { |@line|
			@key = @line.split(/:/).shift
			if str =~ /^\\#{@key}-/
				@category = @line.split(/:/).pop
			end
			}
		if @category == ""
			@category = "Misc"
		end
		return(@category)
	end

	def date_sub(str)
		@time_str = Time.local(@year,@month,@day).strftime("%Y / %m / %d ( %a )")
		@str = "<h2><a id=\"d#{@year}#{@month}#{@day}\" name=\"d#{@year}#{@month}#{@day}\" href=\"#d#{@year}#{@month}#{@day}\">#{@time_str}</a></h2>\n\n#{str}"
		return(@str)
	end

	def title_sub(str)
		@cnt = @cnt.succ!
		@category = categorize(str)
		str.gsub!(/^\\..-/,"\\")
		str.gsub!(/^\\/,"<h3>[<a id=\"d#{@time}_#{@cnt}\" name=\"d#{@time}_#{@cnt}\" href=\"#d#{@time}_#{@cnt}\">#{@category.chomp}</a>] ")
		str.gsub!(/\r\n/,"</h3>~\r\n<p>")
		str.gsub!(/(<h3>\[.*\] )(.*)\((http:\/\/.*)\)/){
			"#{$1}<a href=\"#{$3}\">#{$2}</a>"
			}
		#@str = "<h3>[#{@category.chomp!}] #{@str.chomp!}</h3>~\n<p>"
	end

	def back_sub(str)
		str << "<div class=\"back2\"><a href=\"./\">go2index</a></div>\n"
	end

	def make_fn(str)
		str.gsub!(/\(\*(.*)\)/) {
			@fn_cnt.succ!
			@fn_str << "  <li><a id=\"#{@time}_#{@fn_cnt}_02\" name=\"#{@time}_#{@fn_cnt}_02\" href=\"##{@time}_#{@fn_cnt}_01\">*#{@fn_cnt.to_i.to_s}</a> #{$1}</li>\n"
			"<sup><a id=\"#{@time}_#{@fn_cnt}_01\" name=\"#{@time}_#{@fn_cnt}_01\" href=\"##{@time}_#{@fn_cnt}_02\">*#{@fn_cnt.to_i.to_s}</a></sup>"
			}
		if @fn_str != ""
			@result = "#{str}<ol class=\"fn\">\n#{@fn_str}</ol>\n"
		end
		return(@result)
	end

	def search_filter
		Dir.foreach(@filter_directory) { |@filter_name|
			if @filter_name =~ /.*\.rb/
				@filter_list << "#{@filter_name}\n"
			end
		}
	end

	def filtering(str)
		@filt_str = str
		search_filter
		@filt_str.gsub!("<f>","\n<f>")
		@filt_str.gsub!("</f>","</f>\n")
		@filter_list.each { |@filter|
				load "#{@filter_directory}#{@filter.chomp}"
				@f_method = @filter.sub(".rb","")
				"#{eval(@f_method)}"
		}
		@filt_str.gsub!("<f>","") ; @filt_str.gsub!("</f>","")
		return(@filt_str)
	end

	def blockquote(str)
		str.gsub!(/:quote\((.*)\).*/){
			"<blockquote title=\"#{$1}\">"
			}
		str.gsub!(/:quote.*/,"<blockquote>")
		str.gsub!(/^\/q.*/,"</blockquote>\n")
	end

	def tagescape(str,tag)
		str.gsub!(/^<\/#{tag}>\n/,"</#{tag}>\n<p>")
		str.gsub!(/^<p><#{tag}(.*)>\n/){ ; "<#{tag}#{$1}>\n" ; }
		str.gsub!(/^<p>\n/,"<p>")
		str.gsub!(/<br \/>\n<#{tag}(.*)>/){ ; "<\/p>\n<#{tag}#{$1}>" ; }
		str.gsub!("<p></p>","")
		eof_tag_cut(str)
	end

	def tagescape_fr(str)
		blockquote(str)
	end

	def tagescape_en(str)
		tagescape(str,"blockquote")
		tagescape(str,"code")
		tagescape(str,"ul")
		tagescape(str,"ol")
	end

	def eof_tag_cut(str)
		if str =~ /<p>\z/
			str.gsub!(/<p>\z/,"")
		end
	end

	def xhtml_escape(str)
		str.gsub!("\&","\&amp\;")
	end

	def main
		@comment.each { |@str|
			if @str =~ /^\\/
				title_sub(@str)
			elsif @str =~ /^\r\n/
				@str = "</p>\n"
			end
			unless @str =~ /^<\/p>/
				@str.gsub!("\r\n","<br />\n")
			end
			@str.gsub!("~<br />","")
			tagescape_fr(@str)
			@result << @str
		}
		@result = "#{@result}</p>\n"
		@result.gsub!("<br />\n</p>","</p>\n")
		make_fn(@result)
		tagescape_en(@result)
		back_sub(@result)
		@result = date_sub(@result)
		xhtml_escape(@result)
		@result = filtering(@result)
		return(@result)
	end
end


class Rtds_file
	def initialize
		@str = ""
		@cgi = CGI.new
		@year = @cgi['year'][0]
		@month = @cgi['month'][0]
		@day_tr = @cgi['day'][0]
		@plug_list = ""
	end

	def set_config(title,index_base_file,diary_base_file,index_file,diarytable_file,sufix,plugin_directory)
		@title = title
		@index_base = index_base_file
		@diary_base = diary_base_file
		@index_file = index_file
		@diarytable = diarytable_file
		@sufix = sufix
		@plugin_directory = plugin_directory
		@plugin_files = "#{@plugin_directory}/files"
	end

	def set_property
		if @day_tr.to_i < 16
			@day_sufix = "a"
		else
			@day_sufix = "b"
		end
		@day = "#{@year}/#{@month}#{@day_sufix}"
		@file_name = "#{@year}#{@month}#{@day_sufix}#{@sufix}"
		@addmonth = "#{@month}#{@day_sufix}"
	end			

	def lock(file)
		File::open(file).flock(LOCK_EX)
	end

	def unlock(file)
		File::open(file).flock(LOCK_UN)
	end

	def search_plug_in(str)
		str.each { |@plug_key|
			if @plug_key =~ /^<!-- PLUG-IN-(.*) START -->\n/
				@plug_list << "#{$1}\n"
			end
			}
	end

	def sub_plug_in(str)
		@plug_list.each { |@plug_in_name|
			@plug_in_name.chomp!
			str.gsub!(/<!-- PLUG-IN-#{@plug_in_name} START -->.*<!-- PLUG-IN-#{@plug_in_name} END -->/m){
				@plug_in_code = "rtds_#{@plug_in_name.downcase}"
				load "plug-in/#{@plug_in_code}.rb"
				"<!-- PLUG-IN-#{@plug_in_name} START -->\n#{eval(@plug_in_code)}<!-- PLUG-IN-#{@plug_in_name} END -->"
				}
			}
	end

	def plug_in(str)
		search_plug_in(str)
		sub_plug_in(str)
	end

	def link_diarytable(diarytable_str)
		diarytable_str.gsub!(@day,"<a href=\"./#{@file_name}\">#{@day}</a>")
	end

	def add_diarytable
		@table = open(@diarytable,"r").read
		case @addmonth
			when "01a","04a","07a","10a"
			@addmonth.delete!("a")
			@zero = @addmonth ; @one = @zero.succ ; @two = @one.succ
			@table.gsub!("<!--date-->","<!--date-->\n#{@year}/#{@zero}a | #{@year}/#{@zero}b | #{@year}/#{@one}a | #{@year}/#{@one}b | #{@year}/#{@two}a | #{@year}/#{@two}b<br />")
		end
		link_diarytable(@table)
		lock(@diarytable)
			open(@diarytable,"w").write @table
		unlock(@diarytable)
		return(@table)
	end

	def index_new
		@index = open(@index_base,"r").read
		@table = add_diarytable
		@index.gsub!("RTDS_FILE",@file_name)
		@index.gsub!("DIARYTABLE",@table)
		@index.gsub!("RTDS_VERSION",RTDS)
		plug_in(@index)
		begin
			lock(@index_file)
			open(@index_file,"w").write @index
			unlock(@index_file)
		rescue
			open(@index_file,"w").write @index
		end
		#File.chmod(0755,@index_file)
	end

	def str_add_file(str)
		begin
			@str = open(@file_name,"r").read
		rescue
			@str = open(@diary_base,"r").read
			@str.gsub!("RTDS_MONTH",@day)
			@str.gsub!("RTDS_DIARY","<!-- #{@title} -->")
			#@str.gsub!("RTDS_FILE",@file_name) #=> only use todo.
			@str.gsub!("RTDS_VERSION",RTDS)
			index_new
		ensure
			@str.gsub!("<!-- #{@title} -->","<!-- #{@title} -->\n\n#{str}")
			plug_in(@str)
			begin
				lock(@file_name)
					open(@file_name,"w").write @str
				unlock(@file_name)
			rescue
				open(@file_name,"w").write @str
				#File.chmod(0755,@file_name)
			end
		end
	end
end

rstr = Rtds_str.new
	rstr.set_config(category_file,filter_directory)
	main_str = rstr.main

rfile = Rtds_file.new
	rfile.set_config(title,index_base_file,diary_base_file,index_file,diarytable_file,sufix,plugin_directory)
	rfile.set_property
	rfile.str_add_file(main_str)

	print "Location: ./\n\n"
